// Generated by CoffeeScript 2.7.0
(function() {
  var addSession, canDragDrop, canPlay, checkPassword, formatDuration, formatSize, initUpload, passwordOK, roundSize, setupUpload, theButton, thePlayer, uploadFiles,
    indexOf = [].indexOf;

  canPlay = Modernizr.audio && Modernizr.audio.wav;

  canDragDrop = Modernizr.draganddrop && (indexOf.call(document.createElement('span'), 'draggable') >= 0);

  roundSize = function(sz) {
    if (sz < 10) {
      return Math.floor(sz * 10 + 0.5) / 10;
    } else {
      return Math.floor(sz + 0.5);
    }
  };

  formatDuration = function(duration) {
    var hours, min, ret, sec;
    sec = Math.floor(duration + 0.5);
    min = Math.floor(sec / 60);
    hours = Math.floor(min / 60);
    min = min % 60;
    sec = sec % 60;
    ret = '';
    if (hours) {
      if (hours < 10) {
        ret += '0' + hours;
      } else {
        ret += hours;
      }
      ret += ':';
    }
    if (min < 10) {
      ret += '0' + min;
    } else {
      ret += min;
    }
    ret += ':';
    if (sec < 10) {
      ret += '0' + sec;
    } else {
      ret += sec;
    }
    return ret;
  };

  formatSize = function(sz) {
    if (sz === 1) {
      return "1 byte";
    }
    if (sz < 1024) {
      return sz + " bytes";
    }
    sz /= 1024;
    if (sz < 1024) {
      return roundSize(sz) + " KB";
    }
    sz /= 1024;
    if (sz < 1024) {
      return roundSize(sz) + " MB";
    }
    sz /= 1024;
    return roundSize(sz) + " GB";
  };

  thePlayer = null;

  theButton = null;

  addSession = function(sess) {
    var download, dragURL, play, tr, wavFile, wavURL, wavURLabs;
    wavFile = escape(sess.name) + ".wav";
    wavURL = "down/" + sess.key + "/" + wavFile;
    if (canPlay) {
      play = $('<span></span>').addClass("btn").text('Play');
      play.click(function() {
        var player;
        if (thePlayer) {
          thePlayer.remove();
          theButton.show();
        }
        player = $('<audio></audio>').attr({
          src: wavURL,
          controls: "controls",
          autoplay: "true"
        });
        play.parent().append(player);
        play.hide();
        theButton = play;
        return thePlayer = player;
      });
    }
    download = $('<a>zozo</a>').text(sess.name + ".wav").attr({
      href: wavURL
    });
    wavURLabs = document.location.href + wavURL;
    dragURL = ["audio/x-wav", wavFile, wavURLabs].join(":");
    download.attr({
      draggable: "true",
      "data-downloadurl": dragURL
    });
    tr = $('<tr></tr>');
    tr.append($('<td></td>').html(download));
    tr.append($('<td></td>').text(formatDuration(sess.duration)));
    tr.append($('<td></td>').text(formatSize(sess.disk_usage)));
    tr.append($('<td></td>').text(sess.date));
    if (canPlay) {
      tr.append($('<td></td>').html(play));
    }
    return $('#sessions').append(tr);
  };

  uploadFiles = function(filesArg) {
    var file, files, xhr;
    files = Array.prototype.slice.call(filesArg);
    if (files.length === 0) {
      return;
    }
    file = files[0];
    xhr = new XMLHttpRequest();
    $('#dropzone #progress').css('visibility', 'visible');
    $('#dropzone #progress #fill').css('width', '0%');
    xhr.upload.onprogress = function(e) {
      var fill;
      if (e.lengthComputable) {
        fill = e.loaded * 100 / e.total + '%';
        return $('#dropzone #progress #fill').css('width', fill);
      }
    };
    xhr.onreadystatechange = function() {
      if (xhr.readyState === 4) {
        $('#dropzone #progress').css('visibility', 'hidden');
        return uploadFiles(files.slice(1));
      }
    };
    xhr.open("POST", "/upload");
    xhr.setRequestHeader("Cache-Control", "no-cache");
    xhr.setRequestHeader("X-Requested-With", "XMLHttpRequest");
    xhr.setRequestHeader("X-File-Name", file.name || file.fileName);
    xhr.setRequestHeader("X-File-Size", file.size || file.fileSize);
    xhr.setRequestHeader("Content-Type", "application/octet-stream");
    return xhr.send(file);
  };

  setupUpload = function() {
    var key;
    key = Math.floor(Math.random() * 1000000000000);
    $('#fileupload').fileupload({
      dataType: 'json',
      add: function(e, data) {
        $("#upload-progress").css("visibility", "visible");
        $("#upload-progress").progressbar("option", "value", 100);
        $('#upload-progress').toggleClass("pb-animated", true);
        $('#fileDropZone').removeClass("dragover");
        return uploadFiles(data.files);
      },
      progress: function(e, data) {
        var fill;
        fill = data.loaded * 100 / data.total;
        $('#upload-progress').toggleClass("pb-animated", false);
        return $("#upload-progress").progressbar("option", "value", fill);
      },
      done: function(e, data) {
        return $("#upload-progress").css("visibility", "hidden");
      },
      dropZone: $('#fileDropZone')
    });
    if ($.browser.webkit || $.browser.mozilla) {
      $('#fileDropZone').show();
      $('#fileDropZone').on('dragenter', function(e) {
        $('#fileDropZone').toggleClass("dragover", true);
        return e.stopPropagation();
      });
      $('#fileDropZone').on('dragleave', function(e) {
        $('#fileDropZone').toggleClass("dragover", false);
        return e.stopPropagation();
      });
    }
    return $('#upload').show();
  };

  initUpload = function() {
    return $.ajax('canupload', {
      success: function(can) {
        if (can) {
          return setupUpload();
        }
      }
    });
  };

  passwordOK = function(cb) {
    return $.get('checkpassword', function(ok) {
      return cb(ok !== true);
    });
  };

  checkPassword = function(cb) {
    return passwordOK(function(requires) {
      var pass;
      if (requires) {
        pass = prompt('Enter password:');
        document.cookie = "TW-Password=" + pass;
        return checkPassword(cb);
      } else {
        return cb();
      }
    });
  };

  $(function() {
    return checkPassword(function() {
      var sess;
      initUpload();
      if (window.location.protocol === "file:") {
        sess = {
          name: "blah",
          duration: 123,
          disk_usage: 1000000,
          date: "today",
          key: "k"
        };
        addSession(sess);
        addSession(sess);
        addSession(sess);
        return addSession(sess);
      } else {
        return $.ajax('sessions', {
          success: function(sessions) {
            var i, len, results;
            if (sessions) {
              results = [];
              for (i = 0, len = sessions.length; i < len; i++) {
                sess = sessions[i];
                results.push(addSession(sess));
              }
              return results;
            }
          }
        });
      }
    });
  });

}).call(this);
